package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static b4a.example.contactsutils _cu = null;
public anywheresoftware.b4a.objects.ListViewWrapper _lstcontacts = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
b4a.example.contactsutils._cucontact _c = null;
 //BA.debugLineNum = 26;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 27;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 28;BA.debugLine="cu.Initialize";
_cu._initialize(processBA);
 };
 //BA.debugLineNum = 30;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 31;BA.debugLine="For Each c As cuContact In cu.FindAllContacts(True)";
final anywheresoftware.b4a.BA.IterableList group14 = _cu._findallcontacts(anywheresoftware.b4a.keywords.Common.True);
for (int index14 = 0;index14 < group14.getSize();index14++){
_c = (b4a.example.contactsutils._cucontact)(group14.Get(index14));
 //BA.debugLineNum = 33;BA.debugLine="Log(c.DisplayName)";
anywheresoftware.b4a.keywords.Common.Log(_c.DisplayName);
 }
;
 //BA.debugLineNum = 35;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 41;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 37;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
b4a.example.contactsutils._cucontact _c = null;
 //BA.debugLineNum = 70;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 71;BA.debugLine="Dim c As cuContact";
_c = new b4a.example.contactsutils._cucontact();
 //BA.debugLineNum = 73;BA.debugLine="c=cu.InsertContact(\"jim\",\"1234567890\")";
_c = _cu._insertcontact("jim","1234567890");
 //BA.debugLineNum = 74;BA.debugLine="ToastMessageShow(c.Id, False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.NumberToString(_c.Id),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 75;BA.debugLine="cu.AddPhone(c.Id,\"87909877\",\"home\")";
_cu._addphone(_c.Id,"87909877","home");
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="Dim lstContacts As ListView";
mostCurrent._lstcontacts = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Dim ImageView1 As ImageView";
mostCurrent._imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 22;BA.debugLine="Dim EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _lstcontacts_itemclick(int _position,Object _value) throws Exception{
b4a.example.contactsutils._cucontact _c = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp = null;
anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
b4a.example.contactsutils._cuphone _phone = null;
b4a.example.contactsutils._cuemail _email = null;
 //BA.debugLineNum = 45;BA.debugLine="Sub lstContacts_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 46;BA.debugLine="Dim c As cuContact = Value";
_c = (b4a.example.contactsutils._cucontact)(_value);
 //BA.debugLineNum = 47;BA.debugLine="Dim bmp As Bitmap = cu.GetPhoto(c.Id)";
_bmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
_bmp = _cu._getphoto(_c.Id);
 //BA.debugLineNum = 48;BA.debugLine="If bmp.IsInitialized Then ImageView1.SetBackgroundImage(bmp) Else ImageView1.SetBackgroundImage(Null)";
if (_bmp.IsInitialized()) { 
mostCurrent._imageview1.SetBackgroundImage((android.graphics.Bitmap)(_bmp.getObject()));}
else {
mostCurrent._imageview1.SetBackgroundImage((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null));};
 //BA.debugLineNum = 49;BA.debugLine="Dim sb As StringBuilder";
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 50;BA.debugLine="sb.Initialize";
_sb.Initialize();
 //BA.debugLineNum = 51;BA.debugLine="sb.Append(c.DisplayName).Append(CRLF).Append(\"Note: \").Append(cu.GetNote(c.Id)).Append(CRLF)";
_sb.Append(_c.DisplayName).Append(anywheresoftware.b4a.keywords.Common.CRLF).Append("Note: ").Append(_cu._getnote(_c.Id)).Append(anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 52;BA.debugLine="sb.Append(\"Starred: \").Append(cu.GetStarred(c.Id)).Append(CRLF)";
_sb.Append("Starred: ").Append(String.valueOf(_cu._getstarred(_c.Id))).Append(anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 53;BA.debugLine="For Each phone As cuPhone In cu.GetPhones(c.Id)";
final anywheresoftware.b4a.BA.IterableList group30 = _cu._getphones(_c.Id);
for (int index30 = 0;index30 < group30.getSize();index30++){
_phone = (b4a.example.contactsutils._cuphone)(group30.Get(index30));
 //BA.debugLineNum = 54;BA.debugLine="sb.Append(phone.Number & \", \" & phone.PhoneType).Append(CRLF)";
_sb.Append(_phone.Number+", "+_phone.PhoneType).Append(anywheresoftware.b4a.keywords.Common.CRLF);
 }
;
 //BA.debugLineNum = 56;BA.debugLine="For Each email As cuEmail In cu.GetEmails(c.Id)";
final anywheresoftware.b4a.BA.IterableList group33 = _cu._getemails(_c.Id);
for (int index33 = 0;index33 < group33.getSize();index33++){
_email = (b4a.example.contactsutils._cuemail)(group33.Get(index33));
 //BA.debugLineNum = 57;BA.debugLine="sb.Append(email.email).Append(\", \").Append(email.EmailType).Append(CRLF)";
_sb.Append(_email.Email).Append(", ").Append(_email.EmailType).Append(anywheresoftware.b4a.keywords.Common.CRLF);
 }
;
 //BA.debugLineNum = 59;BA.debugLine="EditText1.Text = sb.ToString";
mostCurrent._edittext1.setText((Object)(_sb.ToString()));
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _lstcontacts_itemlongclick(int _position,Object _value) throws Exception{
b4a.example.contactsutils._cucontact _c = null;
 //BA.debugLineNum = 62;BA.debugLine="Sub lstContacts_ItemLongClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 64;BA.debugLine="Dim c As cuContact = Value";
_c = (b4a.example.contactsutils._cucontact)(_value);
 //BA.debugLineNum = 65;BA.debugLine="cu.SetStarred(c.Id, Not(cu.GetStarred(c.Id)))";
_cu._setstarred(_c.Id,anywheresoftware.b4a.keywords.Common.Not(_cu._getstarred(_c.Id)));
 //BA.debugLineNum = 67;BA.debugLine="lstContacts_ItemClick(Position, Value)";
_lstcontacts_itemclick(_position,_value);
 //BA.debugLineNum = 68;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim cu As ContactsUtils";
_cu = new b4a.example.contactsutils();
 //BA.debugLineNum = 17;BA.debugLine="End Sub";
return "";
}
}
